//*****************************************************************************
// File Name            : max2_lcd_direct.v
//-----------------------------------------------------------------------------
// Function             : max2 led direct output
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//-----------------------------------------------------------------------------
// History
// -.-- 2017/7/25
//*****************************************************************************
module max2_lcd_direct(
    input DCLK_I,
    input VSD_I,
    input HSD_I,
    input [1:0] DATA_R_I,
    input [1:0] DATA_G_I,
    input [1:0] DATA_B_I,
    input DEN_I,
    output KEY1_O,
    output DCLK,
    output VSD,
    output HSD,
    output [7:0] DATA_R,
    output [7:0] DATA_G,
    output [7:0] DATA_B, 
    output DEN,
    output STBYB,
    output LCD_LED,
    input KEY1
    );
	 
	 assign KEY1_O = KEY1;
	 assign STBYB =1'b1;
	 assign LCD_LED = 1'b1;
	 
	 assign DCLK = DCLK_I;
	 assign HSD = HSD_I;
	 assign VSD = VSD_I;
	 assign DEN = DEN_I;
	 assign DATA_R= {DATA_R_I,6'b000000};
	 assign DATA_G= {DATA_G_I,6'b000000};
	 assign DATA_B= {DATA_B_I,6'b000000};
	 
endmodule