//*****************************************************************************
// File Name            : max2_lcd_dmux.v
//-----------------------------------------------------------------------------
// Function             : max2 led dmux output
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//-----------------------------------------------------------------------------
// History
// -.-- 2017/7/25
//*****************************************************************************
module max2_lcd_dmux(
    input DCLK_M,
    input VSD_M,
    input HSD_M,
    input [3:0] DATA_M,
	input DEN_M,
	output KEY1_O,
    output DCLK,
    output VSD,
    output HSD,
    output [7:0] DATA_R,
    output [7:0] DATA_G,
    output [7:0] DATA_B,
	output DEN,
	output STBYB,
	output LCD_LED,
	input KEY1
    );
	 
	 assign KEY1_O = KEY1;
	 assign STBYB =1'b1;
	 assign LCD_LED = 1'b1;
	 
  rgb_dmux rgb_dmux(
  .DCLK_M(   DCLK_M),
  .VSD_M(    VSD_M),
  .HSD_M(    HSD_M),
  .DATA_M(   DATA_M),
  .DEN_M(    DEN_M),
  .DCLK(     DCLK),
  .VSD(      VSD),
  .HSD(      HSD),
  .DATA_R(   DATA_R),
  .DATA_G(   DATA_G),
  .DATA_B(   DATA_B),
  .DEN(      DEN)
  );
	 
endmodule
