//*****************************************************************************
// File Name            : rgb_dmux.v
//-----------------------------------------------------------------------------
// Function             : rgb_dmux
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo 
//-----------------------------------------------------------------------------
// History
// -.-- 2017/4/23
// -.-- 2017/8/31
//*****************************************************************************
module rgb_dmux(
    input DCLK_M,
    //input rstb,
    input VSD_M,
    input HSD_M,
    input [3:0] DATA_M,
	input DEN_M,
	output reg DCLK,
    output VSD,
    output HSD,
    output [7:0] DATA_R,
    output [7:0] DATA_G,
    output [7:0] DATA_B,
	output DEN
    );
    reg vsync_hd;
    reg hsync_hd;
    reg [4:0]data_m_hd;
    reg [4:0]r_da_hold;
    reg [5:0]g_da_hold;
    reg [4:0]b_da_hold;
	 reg den_hd;
    reg vsync_d1;
    reg vsync_d2;
    reg vsync_d3;
    reg vsync_d4;
    reg vsync_d5;
    reg vsync_d6;
    reg vsync_d7;
    reg hsync_d1;
    reg hsync_d2;
    reg hsync_d3;
    reg hsync_d4;
    reg hsync_d5;
    reg hsync_d6;
    reg hsync_d7;
    reg [3:0] da_m_d1;
    reg [3:0] da_m_d2;
    reg [4:0] r_da_od;
    reg [5:0] g_da_od;
    reg [4:0] b_da_od;
/*
    reg [1:0] r_da_d1;
    reg [1:0] r_da_d2;
    reg [4:0] r_da_od;
    reg [1:0] g_da_d1;
    reg [1:0] g_da_d2;
    reg [5:0] g_da_od;
    reg [1:0] b_da_d1;
    reg [1:0] b_da_d2;
    reg [4:0] b_da_od;
*/
	 reg den_d1;
	 reg den_d2;
	 reg den_d3;
	 reg den_d4;
	 reg den_d5;
	 reg den_d6;
	 reg den_d7;
	 reg [1:0]data_sel;

//always @ (negedge DCLK_M)
always @ (posedge DCLK_M)
    begin
	   vsync_hd <=VSD_M;
	   hsync_hd <=HSD_M;
	   den_hd <=DEN_M;
	   data_m_hd <=DATA_M;
    end
	 
always @ (posedge DCLK_M)
    begin
	   vsync_d1 <=vsync_hd;
	   vsync_d2 <=vsync_d1;
	   vsync_d3 <=vsync_d2;
	   vsync_d4 <=vsync_d3;
	   vsync_d5 <=vsync_d4;
	   vsync_d6 <=vsync_d5;
	   vsync_d7 <=vsync_d6;
	   hsync_d1 <=hsync_hd;
	   hsync_d2 <=hsync_d1;
	   hsync_d3 <=hsync_d2;
	   hsync_d4 <=hsync_d3;
	   hsync_d5 <=hsync_d4;
	   hsync_d6 <=hsync_d5;
	   hsync_d7 <=hsync_d6;
	   den_d1 <=den_hd;
	   den_d2 <=den_d1;
	   den_d3 <=den_d2;
	   den_d4 <=den_d3;
	   den_d5 <=den_d4;
	   den_d6 <=den_d5;
	   den_d7 <=den_d6;
    end
	 
always @ (posedge DCLK_M)
    begin
	   //da_m_d1 <= DATA_M;
	   da_m_d1 <= data_m_hd;
	   da_m_d2 <= da_m_d1;
    end
always @ (posedge DCLK_M)
  DCLK = data_sel[1];
	   
always @ (posedge DCLK_M)
  //if (rstb==1'b0) 
  //  data_sel <=0;
  //else
    if((den_d1==1'b1)&&(den_d2==1'b0))
	   data_sel <=2'd0;
    else
	   data_sel <=data_sel + 2'd1;
    /*
	 else if(den_d2==1'b1)
	   data_sel <=data_sel + 2'd1;
	 else
	   data_sel <= 2'd0;
     */

always @ (posedge DCLK_M)
  //if (rstb==1'b0)
  //  begin 
  //    r_da_od <=4'b0000;
  //    g_da_od <=4'b0000;
  //    b_da_od <=4'b0000;
  //	 end
  //else	 
  if(den_d2==1'b1)
	 case(data_sel)
	   2'd0:
	   begin
        //r_da_od <={r_da_od[4],da_m_d2};
        r_da_od <={da_m_d2,r_da_od[0]};
        g_da_od <=g_da_od;
        b_da_od <=b_da_od;
		end
	   2'd1:
	   begin
        r_da_od <={r_da_od[4:1],da_m_d2[3]};
        g_da_od <={da_m_d2[2:0],g_da_od[2:0]};
        b_da_od <=b_da_od;
		end
	   2'd2:
	   begin
        r_da_od <=r_da_od;
        g_da_od <={g_da_od[5:3],da_m_d2[3:1]};
        b_da_od <={da_m_d2[0],b_da_od[3:0]};
		end
	   2'd3:
	   begin
        r_da_od <=r_da_od;
        g_da_od <=g_da_od;
        b_da_od <={b_da_od[4],da_m_d2};
		end
	  endcase
  else
    begin 
      r_da_od <=5'b00000;
      g_da_od <=6'b000000;
      b_da_od <=5'b00000;
    end
		
always @ (posedge DCLK_M)
  if(data_sel==2'd0)
    begin
      r_da_hold<=r_da_od;
      g_da_hold<=g_da_od;
      b_da_hold<=b_da_od;
	end
  else
    begin
      r_da_hold<=r_da_hold;
      g_da_hold<=g_da_hold;
      b_da_hold<=b_da_hold;
	end

  assign VSD = vsync_d7;	 
  assign HSD = hsync_d7;	 
  assign DEN = den_d7;	 
  assign DATA_R = {r_da_hold,3'b000};	 
  assign DATA_G = {g_da_hold,2'b00};	 
  assign DATA_B = {b_da_hold,3'b000};	 
  
endmodule